    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * PaintList.java
    029     * --------------
    030     * (C) Copyright 2003, 2004, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: PaintList.java,v 1.5 2005/10/18 13:24:19 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 13-Aug-2003 : Version 1 (DG);
    040     * 27-Jun-2005 : Fixed equals() method to handle GradientPaint (DG);
    041     *
    042     */
    043
    044    package org.jfree.util;
    045
    046    import java.awt.Paint;
    047    import java.io.IOException;
    048    import java.io.ObjectInputStream;
    049    import java.io.ObjectOutputStream;
    050
    051    import org.jfree.io.SerialUtilities;
    052
    053    /**
    054     * A table of {@link Paint} objects.
    055     *
    056     * @author David Gilbert
    057     */
    058    public class PaintList extends AbstractObjectList {
    059
    060        /**
    061         * Creates a new list.
    062         */
    063        public PaintList() {
    064            super();
    065        }
    066
    067        /**
    068         * Returns a {@link Paint} object from the list.
    069         *
    070         * @param index the index (zero-based).
    071         *
    072         * @return The object.
    073         */
    074        public Paint getPaint(final int index) {
    075            return (Paint) get(index);
    076        }
    077
    078        /**
    079         * Sets the {@link Paint} for an item in the list.  The list is expanded if necessary.
    080         *
    081         * @param index  the index (zero-based).
    082         * @param paint  the {@link Paint}.
    083         */
    084        public void setPaint(final int index, final Paint paint) {
    085            set(index, paint);
    086        }
    087
    088        /**
    089         * Tests the list for equality with another object (typically also a list).
    090         *
    091         * @param obj  the other object (<code>null</code> permitted).
    092         *
    093         * @return A boolean.
    094         */
    095        public boolean equals(final Object obj) {
    096            if (obj == null) {
    097                return false;
    098            }
    099            if (obj == this) {
    100                return true;
    101            }
    102            if (obj instanceof PaintList) {
    103                PaintList that = (PaintList) obj;
    104                int listSize = size();
    105                for (int i = 0; i < listSize; i++) {
    106                   if (!PaintUtilities.equal(getPaint(i), that.getPaint(i))) {
    107                       return false;
    108                   }
    109                }
    110            }
    111            return true;
    112        }
    113
    114        /**
    115         * Returns a hash code value for the object.
    116         *
    117         * @return the hashcode
    118         */
    119        public int hashCode() {
    120            return super.hashCode();
    121        }
    122
    123        /**
    124         * Provides serialization support.
    125         *
    126         * @param stream  the output stream.
    127         *
    128         * @throws IOException  if there is an I/O error.
    129         */
    130        private void writeObject(final ObjectOutputStream stream) throws IOException {
    131
    132            stream.defaultWriteObject();
    133            final int count = size();
    134            stream.writeInt(count);
    135            for (int i = 0; i < count; i++) {
    136                final Paint paint = getPaint(i);
    137                if (paint != null) {
    138                    stream.writeInt(i);
    139                    SerialUtilities.writePaint(paint, stream);
    140                }
    141                else {
    142                    stream.writeInt(-1);
    143                }
    144            }
    145
    146        }
    147
    148        /**
    149         * Provides serialization support.
    150         *
    151         * @param stream  the input stream.
    152         *
    153         * @throws IOException  if there is an I/O error.
    154         * @throws ClassNotFoundException  if there is a classpath problem.
    155         */
    156        private void readObject(final ObjectInputStream stream) throws IOException, ClassNotFoundException {
    157
    158            stream.defaultReadObject();
    159            final int count = stream.readInt();
    160            for (int i = 0; i < count; i++) {
    161                final int index = stream.readInt();
    162                if (index != -1) {
    163                    setPaint(index, SerialUtilities.readPaint(stream));
    164                }
    165            }
    166
    167        }
    168
    169    }
    170